package com.example.tdl.util;

public class MapUtils {

        private static double EARTH_RADIUS = 6371.393;
        private static double rad(double d)
        {
            return d * Math.PI / 180.0;
        }

        /**
         * 计算两个经纬度之间的距离
         * @param lat1
         * @param lng1
         * @param lat2
         * @param lng2
         * @return
         */
        public static double getDistance(double lat1, double lng1, double lat2, double lng2)
        {
            double radLat1 = rad(lat1);
            double radLat2 = rad(lat2);
            double a = radLat1 - radLat2;
            double b = rad(lng1) - rad(lng2);
            double s = 2 * Math.asin(Math.sqrt(Math.pow(Math.sin(a/2),2) +
                    Math.cos(radLat1)*Math.cos(radLat2)*Math.pow(Math.sin(b/2),2)));
            s = s * EARTH_RADIUS;
            s = Math.round(s * 1000);
//            System.out.println("s:"+s);
            return s;
        }


        //计算速度
        public static  double getSpeed(double lat1, double lng1, double lat2, double lng2,Long  time,Float sppeed){


            if(time ==0){
                return 0d;
            }
            double s = getDistance( lat1,  lng1,  lat2,  lng2);
            double speed =  (double) s/time;
//            if((lng1+"") .contains("110.")){
//                System.out.println("lng:" + lng1  +" ----lat:" +lat1 +" ----speed:" + speed  +" ---time :" +time +" -----distance:"+s);
//            }
//            System.out.println("speed:"+speed);
            if(s <1000 || s> 10000){
                //计算速度
                if(speed>250 || speed <sppeed){
//                    if((lng1+"") .contains("110.")){
//                        System.out.println("lng:" + lng1  +" ----lat:" +lat1 +" ----speed:" + speed  +" ---time :" +time +" -----distance:"+s);
//                    }
                    return  0;
                }
                return  s/time;
            }else{
                return s/time;
            }

        }

        public static void main(String[] args) {
            double f = 44300*(1-(Math.pow((1016/1013.25), (float)1/5.256)));
            double h = 44300*(1-(Math.pow((1012/1013.25), (float)1/5.256)));
            double f1 = 44300*(1-(Math.pow((795/1013.25), (float)1/5.256)));
            double f2 = 44300*(1-(Math.pow((616/1013.25), (float)1/5.256)));
            double f3 = 44300*(1-(Math.pow((1013/1013.25), (float)1/5.256)));
            double f4 = 44300*(1-(Math.pow((1013/1013.25), (float)1/5.256)));
            double f5 = 44300*(1-(Math.pow((1013/1013.25), (float)1/5.256)));

            System.out.println(f);
            System.out.println(f1);
            System.out.println(h);


        }

}
